 /* CyLoop.h
 *
 *
 *    this file is part of:
 *
 *    Cyclone   ---   Loop Giant
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Sergio Atzori, 2010
 *
 *
 */ 

#ifndef CYLOOP_H
#define CYLOOP_H

#include <QFileInfo>
#include <QString>
#include "typedefs.h"

class CyLoop {
  
public:
    CyLoop(QString nPath, int indx, int ssn);
    CyLoop(CyLoop *cl);
        
    bool activate();    
    QString passErrorString();  
    QString passName();
    int getIndex();
    QString getName();
    slmode getSLmode();
    smode getSmode();
    int getVolume();
    midiPlayFunction getMidi();
    midiVolumeFunction getMidiV();
    QString loopPath();
    int state;
    iloop loopindex;
    bool dead;
    
    void setIndex(int i);
    void setLoopBuffer(int lp, int ss);
    void setLoopIndex(int lp, int ss);
    void destroyLoopBuffer();
    void closeLoop();
    void setName(QString name);
    void setSLmode(slmode slm);
    void setSmode(smode sm);
    void setVolume(int v);
    void setMidi(midiPlayFunction mpf);
    void setMidiV(midiVolumeFunction mvf);
    void untrigger();
    QString minutes();
    QString seconds();
    int getStrig();
    
    loopresponse playLoop();
    
private:
    QString cyError;
    short int index;
    QString cyname;
    slmode cyslm;
    smode cysm;
    short int cyvolume;
    midiPlayFunction cympf;
    midiVolumeFunction cymvf;
};

#endif