/* CyMidi.h
 *
 *
 *    this file is part of:
 *
 *    Cyclone   ---   Loop Giant
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Sergio Atzori, 2010
 *
 *
 */ 

#ifndef CYMIDI_H
#define CYMIDI_H

#include <QObject>

#include "typedefs.h"

class WinCycle;

class CyMidi : public QObject {
    Q_OBJECT
    
public:
  CyMidi(WinCycle *parent);
  void setListenMidi(bool setting) { listenMidi = setting; }
  bool getListenMidi() { return listenMidi; }
  bool findMidiCurrent(midicmd midic, int sex);
  bool findMidiGlobal(midicmd midic);
  void refresh(int session = 255);
  void refreshGlobal();

  int catchglobalindex;
  int catchglobalval;
  int catchindex;
  int catchsession;
  int catchtype;
  int catchval;
  midicmd mc;
  bool catchlock;
  QString inUseString();
  
  bool localTrig;
  bool localSearch;
  bool listenMidi;
  
  public slots:
    void midi(int type, int num, int val, int ch);
    
  private:
    WinCycle *main; 
    
private slots:
  
};

#endif
 
