/* CyUi.h
 *
 *
 *    this file is part of:
 *
 *    Cyclone   ---   Loop Giant
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Sergio Atzori, 2010
 *
 *
 */ 

#ifndef CYUI_H
#define CYUI_H

#include <QObject>
#include <QSlider>
#include <QPushButton>

#include "Dialogs.h"

class WinCycle;
class QDockWidget;

class CyUi : public QObject {
    Q_OBJECT
    
public:
  CyUi(WinCycle *parent);
  void setupIcons();
  void setupActions();
  void setupButtons();
  void setupMenus();
  void setupUi();
  QDockWidget *setupResources();
  QDockWidget *setupControls();
  void createToolBar();
  void createStatusBar();
  
  Meter *sigMeter;  
  QLabel *volLabel;
  
  public slots:
    void updateStatusPos(int curpos, int curasyncpos, bool async);
    void updateStatusSig(int cursig, int ch);
    
  private:
    void bufferSizeLow();
    CyPosition *posWidget;
    WinCycle *main; 
    QLabel *jackLabel;
    QLabel *messageLabel; 
    QDockWidget *resources;
    QDockWidget *controls;
    
private slots:
  void updateStatusBar(QString msg);
};

#endif
 
