/* JackThread.h
 *
 *
 *    this file is part of:
 *
 *    Cyclone   ---   Loop Giant
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Sergio Atzori, 2010
 *
 *
 */ 

#ifndef JACKTHREAD_H
#define JACKTHREAD_H

#include <alsa/asoundlib.h>
#include <QThread>

class JackThread : public QThread {
    Q_OBJECT

public:
    JackThread();
    void stop();
    int state();
    void killMidi();
    void rstate();
    void stopLooping();
    int sooperlooper_connect();
    void sooperlooper_volume();
    void setDebug(int dbg);
    void setBufferFrames(int bf);
    void setQuickFade(int qf);
    void setVolume(int volume);
    void setStandardCoord(int ii, int ss);
    snd_seq_t *getMidiSeq();
    int getMidiPort();
    
    int slvol;    
    
  signals:
    void tabChanged(int oldi, int olds, int oldstate, int newi, int news, int newstate);
    void jackFinished();
    void statusChanged(QString status);
    void scroll(int xi, int ys);
    void posChanged(int curpos, int curapos, bool ase);
    void sigChanged(int cursig, int ch);
    
protected:
    void run();
    void exec();

private:
    void checkStatus(const char *msg);
    
    bool asyncEnabled;
    int pos;
    int apos;
    int sigL;
    int sigR;
    
    QString clientName;
    char msg_old[16];
};

#endif