/* cyclonic.h
 *
 *
 *    this file is part of:
 *
 *    Cyclone   ---   Loop Giant
 *
 */

#ifndef _CYCLONIC_H_INCLUDED_
#define _CYCLONIC_H_INCLUDED_ 

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <alsa/asoundlib.h>
#include <jack/jack.h>

int cydebug, lsig, rsig;

/*
jack_port_t *input_port1;
jack_port_t *input_port2;
*/

struct statechange {
  int oldi;
  int olds;
  int oldstate;
  int newi;
  int news;
  int newstate;
  int changed;
};

jack_port_t *output_port1;
jack_port_t *output_port2;
snd_seq_t *seqcy;
int midi_in_id;
jack_client_t *client;
char cymidi[6];
char slmidi[6];
char cymsg[16];
int cystate;
int gvolume;
short verify_trigger;
float async_out1[4096];
float async_out2[4096];
int async_process(jack_nframes_t nframes);
int sooloovol;

char *cyclonic_msg();
void cyclonic_stop();
int cyclonic_state();
long cyclonic_samplerate();
int cyclonic(char *nomeclient);
int sl_connect();
int sl_verify();
void cyclonic_stop_looping();
void set_general_volume(int gvol);
void set_standard_coord(int ind, int ses);
int position();
int signalL();
int signalR();
int asyncposition();
int async();
void setsooloovol(int vol);
void cyclonic_kill_midi();

void setDebugCyclonic(int dbg);
void setBufferFramesCyclonic(int bf);
void setQuickFadeCyclonic(int qf);


struct statechange check_bridge();

#endif 
