/* main.cpp
 *
 *
 *    this file is part of:
 *
 *    Cyclone   ---   Loop Giant
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 *  -----------------------------------------------------------
 *
 *  Freely modified by Sergio Atzori, 2010
 *
 *
 */ 

#include <QApplication>
#include <QtGui>

#include "WinCycle.h"

int main(int argv, char **args) {
    QApplication app(argv, args);
    QSplashScreen *splash = new QSplashScreen;
    splash->setPixmap(QPixmap(":/icons/splash.png"));
    splash->show();
    Qt::Alignment topRight = Qt::AlignRight | Qt::AlignTop;
    splash->showMessage(QString("%1 by Sergio Atzori") .arg(QString("©2010").right(5)),
                           topRight, QColor(Qt::blue).darker(400));
    QString fl = QString(args[1]);
    
    /* Retrieve System Locale */
    QString locale = QLocale::system().name();
    
    QTranslator translator;
    translator.load(APPPREF"/share/cyclone/translations/cyclone_" + locale);
    app.installTranslator(&translator);
    
    WinCycle cycle(fl);
    cycle.show();
    splash->finish(&cycle);
    delete splash;

    app.setApplicationName("Cyclone");
    app.setQuitOnLastWindowClosed(true);

    return app.exec();
}