/* slverify.c
 *
 *
 *    this file is part of:
 *
 *    Cyclone   ---   Loop Giant
 *
 * by Sergio Atzori, 2010
 *
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include "slverify.h"

int slverify(snd_seq_t *seq, char *port, char *slport) {
  int queue = 0, convert_time = 0, convert_real = 0, exclusive = 0;
  snd_seq_port_subscribe_t *subs;
  snd_seq_addr_t sender, dest;
  
  if (snd_seq_parse_address(seq, &sender, port) < 0) {
	  fprintf(stderr, "slverify: invalid sender address %s\n", port);
	  return 1;
  }
  
  if (snd_seq_parse_address(seq, &dest, slport) < 0) {
	  fprintf(stderr, "slverify: invalid destination address %s\n", slport);
	  return 1;
  }
  
  snd_seq_port_subscribe_alloca(&subs);
  snd_seq_port_subscribe_set_sender(subs, &sender);
  snd_seq_port_subscribe_set_dest(subs, &dest);
  snd_seq_port_subscribe_set_queue(subs, queue);
  snd_seq_port_subscribe_set_exclusive(subs, exclusive);
  snd_seq_port_subscribe_set_time_update(subs, convert_time);
  snd_seq_port_subscribe_set_time_real(subs, convert_real);
  
  if (snd_seq_get_port_subscription(seq, subs) == 0) {
	  return 0;
  }
  
  return 1;
}
