#ifndef TYPEDEFS_H
#define TYPEDEFS_H

enum slmodeT { Record, Multiply, RecOverdub, MultiOverdub, None };
enum smodeT { EndLoop, Instantaneous, Once, Asynchronous };
enum fnT { PC, NT };

struct midiPlayFunctionT {
  fnT fn;
  unsigned char ch;
  unsigned char val;
};

struct midiVolumeFunctionT {
  unsigned char ch;
  unsigned char val;
};

struct midicmdT {
  unsigned char type;
  unsigned char ch;
  unsigned char num;
  unsigned char val;
};

struct loopindex {
  char path[256];
  unsigned char index;
  unsigned char session;
};

struct response {
  short int oldindex;
  short int oldsession;
  short int oldstate;
  short int currentindex;
  short int currentsession;
  short int currentstate;
};

struct _midicell {
  unsigned char index;
  bool active;
};

typedef _midicell midicell;
typedef response loopresponse;
typedef loopindex iloop;
typedef slmodeT slmode;
typedef smodeT smode;
typedef midicmdT midicmd;
typedef midiPlayFunctionT midiPlayFunction;
typedef midiVolumeFunctionT midiVolumeFunction; 

#endif